###################################################
### chunk number 1: 
###################################################
#line 16 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
if (!exists("data.table",.GlobalEnv)) library(data.table)  
# In devel won't call library, but R CMD build/check will.
rm(list=as.character(tables()$NAME))  
# for development when we Sweave this file repeatedly. Otherwise first tables() shows tables from last run


###################################################
### chunk number 2: 
###################################################
#line 46 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DF = data.frame(x=c("b","b","b","a","a"),v=rnorm(5))
DF


###################################################
### chunk number 3: 
###################################################
#line 51 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DT = data.table(x=c("b","b","b","a","a"),v=rnorm(5))
DT


###################################################
### chunk number 4: 
###################################################
#line 58 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
CARS = data.table(cars)
head(CARS)


###################################################
### chunk number 5: 
###################################################
#line 64 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
tables()


###################################################
### chunk number 6: 
###################################################
#line 77 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
sapply(DT,class)


###################################################
### chunk number 7: 
###################################################
#line 105 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
tables()
DT


###################################################
### chunk number 8: 
###################################################
#line 112 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DT[2,]
DT[DT$x=="b",]


###################################################
### chunk number 9: 
###################################################
#line 118 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
cat(try(DT["b",],silent=TRUE))


###################################################
### chunk number 10: 
###################################################
#line 123 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
setkey(DT,x)   # or key(DT)="x" if you prefer
DT


###################################################
### chunk number 11: 
###################################################
#line 133 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
tables()


###################################################
### chunk number 12: 
###################################################
#line 139 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DT["b",]


###################################################
### chunk number 13: 
###################################################
#line 145 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DT["b",mult="first"]
DT["b",mult="last"]


###################################################
### chunk number 14: 
###################################################
#line 152 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DT["b"]


###################################################
### chunk number 15: 
###################################################
#line 158 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
grpsize = ceiling(1e7/26^2)   # 10 million rows, 676 groups
tt=system.time( DF <- data.frame(
  x=rep(factor(LETTERS),each=26*grpsize),
  y=rep(factor(letters),each=grpsize),
  v=runif(grpsize*26^2))
)
head(DF,3)
tail(DF,3)
dim(DF)


###################################################
### chunk number 16: 
###################################################
#line 176 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
tt=system.time(ans1 <- DF[DF$x=="R" & DF$y=="h",])   # 'vector scan'
head(ans1,3)
dim(ans1)


###################################################
### chunk number 17: 
###################################################
#line 184 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DT = data.table(DF)
setkey(DT,x,y)


###################################################
### chunk number 18: 
###################################################
#line 188 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
ss=system.time(ans2 <- DT[J("R","h")])   # binary search
head(ans2,3)
dim(ans2)
identical(ans1$v, ans2$v)


###################################################
### chunk number 19: 
###################################################
#line 194 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
if(!identical(ans1$v, ans2$v)) stop("vector scan vs binary search not equal")


###################################################
### chunk number 20: 
###################################################
#line 205 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
system.time(ans1 <- DT[x=="R" & y=="h",])   # works but is using data.table badly
system.time(ans2 <- DF[DF$x=="R" & DF$y=="h",])   # the data.frame way
mapply(identical,ans1,ans2)


###################################################
### chunk number 21: 
###################################################
#line 223 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
identical( DT[J("R","h"),],
           DT[data.table("R","h"),])


###################################################
### chunk number 22: 
###################################################
#line 227 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
if(!identical(DT[J("R","h"),],DT[data.table("R","h"),])) stop("J != data.table check")


###################################################
### chunk number 23: 
###################################################
#line 248 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DT[,sum(v)]


###################################################
### chunk number 24: 
###################################################
#line 254 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
DT[,sum(v),by=x]


###################################################
### chunk number 25: 
###################################################
#line 260 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
ttt=system.time(tt <- tapply(DT$v,DT$x,sum)); ttt
sss=system.time(ss <- DT[,sum(v),by=x]); sss
head(tt)
head(ss)
identical(as.vector(tt), ss$V1)


###################################################
### chunk number 26: 
###################################################
#line 267 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
if(!identical(as.vector(tt), ss$V1)) stop("by check failed")


###################################################
### chunk number 27: 
###################################################
#line 276 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
ttt=system.time(tt <- tapply(DT$v,list(DT$x,DT$y),sum)); ttt
sss=system.time(ss <- DT[,sum(v),by="x,y"]); sss
tt[1:5,1:5]
head(ss)
identical(as.vector(t(tt)), ss$V1)


###################################################
### chunk number 28: 
###################################################
#line 283 "d:/Rcompile/CRANpkg/local/2.12/data.table/inst/doc/datatable-intro.Rnw"
if(!identical(as.vector(t(tt)), ss$V1)) stop("group check failed")


